#!/usr/bin/perl -w

# LSB Test Execution Framework
# Browse for File/Directory Module (choose_file.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':mode';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if (!$_GET{'_frame'}) {
	my $root = (defined($_GET{'root'}) ? $_GET{'root'} : '/');
	my $hidden = (defined($_GET{'hidden'}) ? $_GET{'hidden'} : '1');
	escape($root);
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>File System</title>
</head>

<frameset rows="*, 60" onload="javascript:bottom_frame.get_paths_list();">
  <frame src="choose_file.pl?_frame=top&amp;root=$root&amp;hidden=$hidden" name="top_frame" id="top_frame" />
  <frame src="choose_file.pl?_frame=bottom" name="bottom_frame" id="bottom_frame" scrolling="no" />
  <noframes>
    <body><h1 style="color: red;">Your browser does not support frames!</h1></body>
  </noframes>
</frameset>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'bottom') {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <style type="text/css">
	a {
		color: blue;
	}
  </style>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
  <tr>
    <td align="right">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td height="40" style="width: 10em; text-align: left;"><a href="" onclick="javascript:parent.top_frame.edit_list(); return false;">Selected entries: <span id="num_elems">&hellip;</span></a></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
          <td><input type="button" value="Finish" style="border: 1px solid black; background: white; width: 8em; font-weight: bold;" onclick="javascript:put_paths_list();" /></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Here we store all the entries the user marked.
var paths_list = new Array();
var num_paths_list = 0;
var paths_list_complete = false;

// Saves the list of currently entered files/dirs into local variable.
function get_paths_list() {
	if (parent.opener) {
		var elem_parent = parent.opener.document.getElementById('paths');
		if (elem_parent && elem_parent.value) {
			var arr = elem_parent.value.split('\\n');
			for (var i in arr) {
				var path = arr[i].replace(/^\\s*(.*?)\\s*\$/g, '\$1');
				if ((path != '') && !paths_list[path]) {
					paths_list[path] = true;
					++num_paths_list;
				}
			}
		}
		var elem = document.getElementById('num_elems');
		if (elem)
			elem.innerHTML = num_paths_list;
		paths_list_complete = true;
		parent.top_frame.check_items();
	}
}

// Writes the list of selected files and directories back into the main window
// and closes the dialog.
function put_paths_list() {
	if (parent.opener) {
		var first_elem = '';    // Can be used for filling in the Application Name field
		var elem = parent.opener.document.getElementById('paths');
		if (elem) {
			var to_add = '';
			for (var path in paths_list) {
				if (paths_list[path]) {
					to_add += path + '\\n';
					if (first_elem == '') {
						first_elem = path.substr(path.lastIndexOf('/') + 1);
					}
				}
			}
			elem.value = to_add;
		}
		var app_name = parent.opener.document.getElementById('application');
		if (app_name && (app_name.value == '') && (num_paths_list == 1)) {
			app_name.value = first_elem;
			app_name.style.borderColor = parent.opener.input_border_color;
		}
	}
	parent.window.close();
}
// ]]>
</script>

</body>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'top') {

my $cut_path = $_GET{'root'};
$cut_path = "/$cut_path" if ($cut_path !~ m!^/!);

# Obtain the real path that is closest to the requested one
while (($cut_path ne '') and (!-d $cut_path)) {
	$cut_path =~ s!/[^/]*$!!;
}

if ($cut_path eq '/') {
	$cut_path = '';
}

# Current path
my $path = (($cut_path eq '') ? '/' : $cut_path);

# Whether to show hidden files
my $show_hidden = (defined($_GET{'hidden'}) ? ($_GET{'hidden'} ? '1' : '0') : '1');

print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main td.selected {
		color: red;
	}
	a {
		color: blue;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
    .tab-active {
        border: solid 1px #166a98;
        border-bottom: none;
        background-color: #a0d5f1;
        color: #004060;
        font-size: smaller;
    }
    .tab-inactive {
        cursor: pointer;
        border: solid 1px #166a98;
        font-size: smaller;
    }
    .tab-inactive:hover {
        background-color: #d9eefd;
        color: #004060;
    }
  </style>
</head>

<body onload="javascript:check_items();">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Select Files and Directories:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse_file_dir" target="_blank">Help</a></h3></td>
  </tr>
</table>

<table cellpadding="0" cellspacing="0" border="0" width="100%" style="white-space: nowrap; padding-top: 0.7em;">
  <tr>
    <td style="width: 20px; border-bottom: solid 1px #166a98; height: 1.2em;"><img src="images/environment-spacer.gif" width="20" height="1" alt="" /></td>
    <td align="center" class="tab-active" id="cur-dir-tab" style="width: 13em;" onclick="javascript:show_dir();"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><b>Current&nbsp;Directory</b><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><br /><img src="images/environment-spacer.gif" style="width: 13em;" height="1" alt="" /></td>
    <td style="width: 10px; border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td align="center" class="tab-inactive" id="all-items-tab" style="width: 13em;" onclick="javascript:edit_list();"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><b>All&nbsp;Selected</b><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><br /><img src="images/environment-spacer.gif" style="width: 13em;" height="1" alt="" /></td>
    <td style="border-bottom: solid 1px #166a98; width: 100%;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="5" style="background-color: #a0d5f1; height: 3px; border-left: solid 1px #166a98; border-right: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="5" style="border: solid 1px #166a98; border-top: none; padding: 10px;">

<div id="cur-dir">
<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin-bottom: 10px;">
  <tr>
    <td align="left" width="100%">
DATA

my @path_dirs = split(/\//, $path);
my $cur_path = '';
my $cur_path_esc = '';
print "<a href=\"choose_file.pl?_frame=top&amp;root=%2F&amp;hidden=$show_hidden\"><b>root</b></a>";
foreach $dir (@path_dirs) {
	next if (!$dir);
	$cur_path .= "/$dir";
	$cur_path_esc = $cur_path;
	escape($cur_path_esc);
	print " / <a href=\"choose_file.pl?_frame=top&amp;root=$cur_path_esc&amp;hidden=$show_hidden\">$dir</a>";
}
my $inv_show_hidden = ($show_hidden ? '0' : '1');
my $checked = ($show_hidden ? ' checked="checked"' : '');
print <<DATA;
</td>
  </tr>
  <tr>
    <td style="height: 0.5em;"><img src="images/environment-spacer.gif" width="1" height="1" border="0" alt="" /></td>
  </tr>
  <tr>
    <td><label><input type="checkbox"$checked onclick="javascript:document.location='choose_file.pl?_frame=top&amp;root=$cur_path_esc&amp;hidden=$inv_show_hidden';" />&nbsp;Show&nbsp;hidden</label></td>
  </tr>
</table>

DATA

if (!opendir(CUR_DIR, $path)) {
	print "<b><font color=\"red\">Error: Could not open directory!</font><br />$!</b>\n";
}
else {
	my @listing;
	if ($show_hidden) {
		@listing = grep(!/^\.+$/, readdir(CUR_DIR));
	}
	else {
		@listing = grep(!/^\./, readdir(CUR_DIR));
	}
	closedir(CUR_DIR);

	print <<DATA;
<div id="wrong_files" style="display: none;">
<font color="red"><b>WARNING:</b></font> The following entries from this directory are selected but do not exist:<br />
<div id="wrong_files_data">
</div>
<br />
</div>

<table class="main">
  <tr>
    <th style="width: 1.2em;"></th>
    <th colspan="2">Name</th>
    <th>Size</th>
    <th>Date/Time</th>
    <th>Owner</th>
    <th>Attr</th>
  </tr>
DATA

	my %file_info = ();
	my %dir_info = ();

	foreach my $name (@listing) {
		my @lstat_data = lstat("$cut_path/$name");
		if (scalar(@lstat_data) > 0) {
			my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = @lstat_data ;
			my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
			my $date_time = sprintf('%04d-%02d-%02d %02d:%02d', ($year + 1900), ($mon + 1), $mday, $hour, $min);
			my $owner = (getpwuid($uid) or $uid);
			my $group = (getgrgid($gid) or $gid);
			my $lnk_target = readlink("$cut_path/$name");
			my $isdir = (-d "$cut_path/$name");

			my $fmt_mode = '';
			if (($mode & S_IFSOCK) == S_IFSOCK) {
				# Socket
				$fmt_mode = 's';
			}
			elsif (($mode & S_IFLNK) == S_IFLNK) {
				# Symbolic link
				$fmt_mode = 'l';
			}
			elsif (($mode & S_IFREG) == S_IFREG) {
				# Regular file
				$fmt_mode = '-';
			}
			elsif (($mode & S_IFBLK) == S_IFBLK) {
				# Block device
				$fmt_mode = 'b';
			}
			elsif (($mode & S_IFDIR) == S_IFDIR) {
				# Directory
				$fmt_mode = 'd';
			}
			elsif (($mode & S_IFCHR) == S_IFCHR) {
				# Character device
				$fmt_mode = 'c';
			}
			elsif (($mode & S_IFIFO) == S_IFIFO) {
				# FIFO
				$fmt_mode = 'p';
			}
			else {
				$fmt_mode = '-';
			}
			$fmt_mode .= (($mode & S_IRUSR) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWUSR) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISUID) ? (($mode & S_IXUSR) ? 's' : 'S') : (($mode & S_IXUSR) ? 'x' : '-'));
			$fmt_mode .= (($mode & S_IRGRP) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWGRP) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISGID) ? (($mode & S_IXGRP) ? 's' : 'S') : (($mode & S_IXGRP) ? 'x' : '-'));
			$fmt_mode .= (($mode & S_IROTH) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWOTH) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISVTX) ? (($mode & S_IXOTH) ? 't' : 'T') : (($mode & S_IXOTH) ? 'x' : '-'));

			if ($isdir) {
				$dir_info{$name}{'SIZE'} = $size;
				$dir_info{$name}{'DATE_TIME'} = "$date_time";
				$dir_info{$name}{'OWNER'} = "$owner:$group";
				$dir_info{$name}{'ATTR'} = $fmt_mode;
				$dir_info{$name}{'LINK'} = ($lnk_target ? " title=\"Symbolic link to $lnk_target\"" : '');
			}
			else {
				$file_info{$name}{'SIZE'} = $size;
				$file_info{$name}{'DATE_TIME'} = "$date_time";
				$file_info{$name}{'OWNER'} = "$owner:$group";
				$file_info{$name}{'ATTR'} = $fmt_mode;
				$file_info{$name}{'VALID_LINK'} = (scalar(stat("$cut_path/$name")) != 0);
				$file_info{$name}{'LINK'} = ($lnk_target ? " title=\"Symbolic link to $lnk_target".($file_info{$name}{'VALID_LINK'} ? '' : ' (BROKEN!)')."\"" : '');
			}
		}
		else {
			# File could have been deleted at this moment, ignore it.
			# But other errors we'll display.
			if (!$!{'ENOENT'}) {
				$file_info{$name}{'ERROR'} = $!;
			}
		}
	}

	my $odd_line = 0;
	my $name_to_id = '';

	foreach $name (sort keys %dir_info) {
		my $tmp_path = "$cut_path/$name";
		escape($tmp_path);
		my $name_id = $name;
		$name_id =~ s/([^a-zA-Z0-9\-_:])/sprintf('.%02X', ord($1))/eg;
		my $name_disp = $name;
		$name_disp =~ s/&/&amp;/g;
		my $img = ($dir_info{$name}{'LINK'} ? 'sel_ldir.png' : 'sel_dir.png');
		print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:document.location='choose_file.pl?_frame=top&amp;root=$tmp_path&amp;hidden=$show_hidden';">
    <td onclick="javascript:selectItem('$name_id', '$name', true);event.cancelBubble = true;"><input type="checkbox" name="chk-$name_id" id="chk-$name_id" onclick="javascript:selectItem('$name_id', '$name', false);event.cancelBubble = true;" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"$dir_info{$name}{'LINK'}><img src="images/$img" width="14" height="12" alt="D" /></td>
    <td id="item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"$dir_info{$name}{'LINK'}><b>$name_disp</b></td>
    <td align="right" style="width: 4em;">$dir_info{$name}{'SIZE'}</td>
    <td>$dir_info{$name}{'DATE_TIME'}</td>
    <td>$dir_info{$name}{'OWNER'}</td>
    <td>$dir_info{$name}{'ATTR'}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
		$name_to_id .= "\tname_to_id['$name'] = '$name_id';\n";
	}

	foreach $name (sort keys %file_info) {
		my $name_id = $name;
		$name_id =~ s/([^a-zA-Z0-9\-_:])/sprintf('.%02X', ord($1))/eg;
		my $name_disp = $name;
		$name_disp =~ s/&/&amp;/g;
		if (!$file_info{$name}{'ERROR'}) {
			my $img = ($file_info{$name}{'LINK'} ? ($file_info{$name}{'VALID_LINK'} ? 'sel_lfile.png' : 'sel_lbad.png') : 'sel_file.png');
			print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:selectItem('$name_id', '$name', true);">
    <td><input type="checkbox" name="chk-$name_id" id="chk-$name_id" onclick="javascript:selectItem('$name_id', '$name', false);event.cancelBubble = true;" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"$file_info{$name}{'LINK'}><img src="images/$img" width="11" height="14" alt="F" /></td>
    <td id="item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"$file_info{$name}{'LINK'}><b>$name_disp</b></td>
    <td align="right" style="width: 4em;">$file_info{$name}{'SIZE'}</td>
    <td>$file_info{$name}{'DATE_TIME'}</td>
    <td>$file_info{$name}{'OWNER'}</td>
    <td>$file_info{$name}{'ATTR'}</td>
  </tr>
DATA
		}
		else {
			print <<DATA;
  <tr class="list_item$odd_line">
    <td><input type="checkbox" name="chk-$name_id" id="chk-$name_id" disabled="disabled" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"><img src="images/sel_lbad.png" width="11" height="14" alt="B" /></td>
    <td id="item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"><b>$name_disp</b></td>
    <td colspan="4" align="center"><b><font color="red">&lt;$file_info{$name}{'ERROR'}&gt;</font></b></td>
  </tr>
DATA
		}
		$odd_line = 1 - $odd_line;
		$name_to_id .= "\tname_to_id['$name'] = '$name_id';\n";
	}

	print <<DATA;
</table>
</div>

<div id="all-items" style="display: none;">
</div>

    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Variable containing currently opened path.
var current_path = '$cut_path';

// Array for getting element id from file name.
// JS regular expressions seem to be too weak for this task...
var name_to_id = new Array();

// Perl-generated function to fill name_to_id values.
function fill_name_to_id() {
$name_to_id
}

// Array for storing names of the missing files.
var wrong_files = new Array();

// Synchronization variable
var check_items_performed = false;

// Checks the elements checkboxes according to the previous selection
function check_items() {
	// Protect ourselves from JS errors in case the function is called prior to
	// loading the bottom frame. It will be called again from there, so for now
	// simply exit.
	if (!parent.bottom_frame.paths_list_complete)
		return;

	// Protect from double-execution, if the first call did succeed.
	if (check_items_performed)
		return;

	check_items_performed = true;

	if (parent.opener) {
		var elem_hidden = parent.opener.document.getElementById('show_hidden_files');
		if (elem_hidden)
			elem_hidden.value = '$show_hidden';
		var elem_last_dir = parent.opener.document.getElementById('last_opened_dir');
		if (elem_last_dir)
			elem_last_dir.value = '$path';
	}

	// First, fill in the name_to_id array.
	fill_name_to_id();

	// Then set the checkmarks.
	for (var path in parent.bottom_frame.paths_list) {
		if (parent.bottom_frame.paths_list[path]) {
			var pos = path.lastIndexOf('/');
			var file_name = path.substr(pos + 1);
			var dir = path.substr(0, pos);
			if (dir == current_path) {
				var file_name_id = name_to_id[file_name];
				if (!file_name_id)
					wrong_files.push(file_name);
				else {
					var elem = document.getElementById('chk-' + file_name_id);
					if (elem)
						elem.checked = true;
					elem = document.getElementById('item-' + file_name_id);
					if (elem)
						elem.className = 'selected';
				}
			}
		}
	}

	// Process missing files if any.
	if (wrong_files.length != 0) {
		var wf_div = document.getElementById('wrong_files');
		var wf_data = document.getElementById('wrong_files_data');
		if (wf_div && wf_data) {
			var str = '<table class="main">\\n';
			for (var i in wrong_files) {
				str += '  <tr>\\n    <td style="width: 1.4em;"><input type="checkbox" name="wf-chk-' + i + '" id="wf-chk-' + i + '" checked="checked" onclick="javascript:selectWFItem(' + i + ');" /></td>\\n    <td id="wf-item-' + i + '" class="selected" style="width: 20em;"><strike><b>' + wrong_files[i].replace(/&/g, '&amp;') + '</b></strike></td>\\n  </tr>\\n';
			}
			str += '</table>\\n';
			wf_data.innerHTML = str;
			wf_div.style.display = '';
		}
	}
}

// Updates internal information when (un)selecting files and dirs.
function selectItem(elem_id, file_name, set_checkbox) {
	var checkbox = document.getElementById('chk-' + elem_id);
	var item = document.getElementById('item-' + elem_id);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	var full_path = current_path + '/' + file_name;
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
		item.className = '';
	}
	var elem = parent.bottom_frame.document.getElementById('num_elems');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_paths_list;
}

// Updates internal information when (un)selecting missing files and dirs.
function selectWFItem(elem_num) {
	var checkbox = document.getElementById('wf-chk-' + elem_num);
	var item = document.getElementById('wf-item-' + elem_num);
	if (!checkbox || !item)
		return;
	var full_path = current_path + '/' + wrong_files[elem_num];
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
		item.className = '';
	}
	var elem = parent.bottom_frame.document.getElementById('num_elems');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_paths_list;
}

// Displays the tab with the full list of currently selected files/dirs.
function edit_list() {
	var cur_dir = document.getElementById('cur-dir');
	var all_items = document.getElementById('all-items');
	var cur_dir_tab = document.getElementById('cur-dir-tab');
	var all_items_tab = document.getElementById('all-items-tab');
	if (!cur_dir || !all_items || !cur_dir_tab || !all_items_tab)
		return;
	if (all_items_tab.className == 'tab-active')
		return;
	var str = '';
	var i = 0;
	for (var path in parent.bottom_frame.paths_list) {
		if (parent.bottom_frame.paths_list[path]) {
			str += '  <tr class="clickable" onclick="javascript:selectAFItem(' + i + ', \\'' + path + '\\', true);">\\n    <td style="width: 1.4em;"><input type="checkbox" name="af-chk-' + i + '" id="af-chk-' + i + '" checked="checked" onclick="javascript:selectAFItem(' + i + ', \\'' + path + '\\', false);event.cancelBubble=true;" /></td>\\n    <td id="af-item-' + i + '" class="selected" style="width: 20em;"><b>' + path.replace(/&/g, '&amp;') + '</b></td>\\n  </tr>\\n';
			++i;
		}

	}
	if (str != '')
		str = 'List of all currently selected entries:\\n<table class="main" style="margin-top: 10px;">\\n' + str + '</table>';
	else
		str = '<i>There are no selected files and directories.</i>';
	all_items.innerHTML = str;
	cur_dir_tab.className = 'tab-inactive';
	all_items_tab.className = 'tab-active';
	cur_dir.style.display = 'none';
	all_items.style.display = '';
}

// Updates internal information when (un)selecting missing files and dirs.
function selectAFItem(elem_num, full_path, set_checkbox) {
	var checkbox = document.getElementById('af-chk-' + elem_num);
	var item = document.getElementById('af-item-' + elem_num);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
		item.className = '';
	}
	var elem = parent.bottom_frame.document.getElementById('num_elems');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_paths_list;
}

// Displays the tab with the contents of the current directory.
function show_dir() {
	var cur_dir = document.getElementById('cur-dir');
	var all_items = document.getElementById('all-items');
	var cur_dir_tab = document.getElementById('cur-dir-tab');
	var all_items_tab = document.getElementById('all-items-tab');
	if (!cur_dir || !all_items || !cur_dir_tab || !all_items_tab)
		return;
	if (cur_dir_tab.className == 'tab-active')
		return;
	all_items_tab.className = 'tab-inactive';
	cur_dir_tab.className = 'tab-active';
	all_items.style.display = 'none';
	cur_dir.style.display = '';
}
// ]]>
</script>
DATA
}

print <<DATA;
</body>
</html>
DATA
}
else {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Error</title>
</head>

<body>
<h2 style="color: red;">Wrong "_frame" argument!</h2>
</body>
</html>
DATA
}
