#!/usr/bin/perl -w

# LSB Test Execution Framework
# Browse for RPM/DEB Packages Module (choose_pkg.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;

autoflush_on();

my $packager = ($is_packager_rpm ? 'RPM' : 'DEB');

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if (!$_GET{'_frame'}) {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>$packager Packages</title>
</head>

<frameset rows="*, 60" onload="javascript:bottom_frame.get_pkgs_list();">
  <frame src="choose_pkg.pl?_frame=top" name="top_frame" id="top_frame" />
  <frame src="choose_pkg.pl?_frame=bottom" name="bottom_frame" id="bottom_frame" scrolling="no" />
  <noframes>
    <body><h1 style="color: red;">Your browser does not support frames!</h1></body>
  </noframes>
</frameset>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'bottom') {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
  <tr>
    <td align="right">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td height="40" style="width: 10em; text-align: left;">Selected packages: <span id="num_pkgs">&hellip;</span></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
          <td><input type="button" value="Finish" style="border: 1px solid black; background: white; width: 8em; font-weight: bold;" onclick="javascript:put_pkgs_list();" /></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Here we store all the packages the user marked.
var pkgs_list = new Array();
var num_pkgs_list = 0;                  // Will be counted by the top_frame.check_items().
var pkgs_list_complete = false;

// Saves the list of currently entered packages into local variable.
function get_pkgs_list() {
	if (parent.opener) {
		var elem_parent = parent.opener.document.getElementById('packages');
		if (elem_parent && elem_parent.value) {
			var arr = elem_parent.value.split('\\n');
			for (var i in arr) {
				var pkg = arr[i].replace(/^\\s*(.*?)\\s*\$/g, '\$1');
				if ((pkg != '') && !pkgs_list[pkg]) {
					pkgs_list[pkg] = true;
				}
			}
		}
		pkgs_list_complete = true;
		parent.top_frame.check_items();
	}
}

// Writes the list of selected packages back into the main window
// and closes the dialog.
function put_pkgs_list() {
	if (parent.opener) {
		var first_elem = '';    // Can be used for filling in the Application Name field
		var elem = parent.opener.document.getElementById('packages');
		if (elem) {
			var to_add = '';
			for (var pkg in pkgs_list) {
				if (pkgs_list[pkg]) {
					to_add += pkg + '\\n';
					if (first_elem == '') {
						first_elem = pkg;
					}
				}
			}
			elem.value = to_add;
		}
		var app_name = parent.opener.document.getElementById('application');
		if (app_name && (app_name.value == '') && (num_pkgs_list == 1)) {
			app_name.value = first_elem;
			app_name.style.borderColor = parent.opener.input_border_color;
		}
	}
	parent.window.close();
}
// ]]>
</script>

</body>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'top') {
print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main td.selected {
		color: red;
	}
	a {
		color: blue;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
  </style>
</head>

<body onload="javascript:check_items();">

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Select Installed $packager Packages:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse_pkg" target="_blank">Help</a></h3></td>
  </tr>
</table>

<br />
<div id="progress_info">
<font color="green"><b>Please, wait while the list of packages is being retrieved&hellip;</b></font><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span>
</div>

<div id="wrong_pkgs" style="display: none;">
<font color="red"><b>WARNING:</b></font> The following packages are selected but do not exist:<br />
<div id="wrong_pkgs_data">
</div>
<br />
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = false;

function update_timer() {
	++elapsed_time;
	var elem = document.getElementById('timer');
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = '';
		tmp += (m < 10) ? '0' + m : m;
		tmp += ':';
		tmp += (s < 10) ? '0' + s : s;
		elem.innerHTML = tmp;
		setTimeout('update_timer()', 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>

DATA

my @packages = split(/\n/, ($is_packager_rpm ?
	`rpm -qa --qf "\%\{NAME\}\\t\%\{VERSION\}\\t\%\{RELEASE\}\\n" | sort` :
	`dpkg-query -W -f '\${Package}\t\${Version}\t\${Status}\n' | sort`
));

my $odd_line = 0;
my $table_data = '';

if ($is_packager_rpm) {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th style="width: 1.2em;"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
    <th>Release</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $rel) = split(/\t/, $pkg, 3);
		# Skip GPG/DSA public keys stored in RPM database
		next if ($name eq 'gpg-pubkey');
		my ($name_disp, $ver_disp, $rel_disp) = ($name, $ver, $rel);
		$name_disp =~ s/&/&amp;/g;
		$ver_disp  =~ s/&/&amp;/g;
		$rel_disp  =~ s/&/&amp;/g;
		my ($name_id, $ver_id, $rel_id) = ($name, $ver, $rel);
		$name_id =~ s/([^a-zA-Z0-9\-_])/sprintf('.%02X', ord($1))/eg;
		$ver_id  =~ s/([^a-zA-Z0-9\-_])/sprintf('.%02X', ord($1))/eg;
		$rel_id  =~ s/([^a-zA-Z0-9\-_])/sprintf('.%02X', ord($1))/eg;
		my $pkg_id = "$name_id\:\:$ver_id\:\:$rel_id";
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:selectItem('$pkg_id', '$name-$ver-$rel', true);">
    <td align="center"><input type="checkbox" id="chk-$pkg_id" name="chk-$name_id" onclick="javascript:selectItem('$pkg_id', '$name-$ver-$rel', false);event.cancelBubble = true;" /></td>
    <td id="item-$pkg_id"><b>$name_disp</b></td>
    <td>$ver_disp</td>
    <td>$rel_disp</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}
else {
	$table_data = <<DATA;
<table class="main">
  <tr>
    <th style="width: 1.2em;"></th>
    <th style="width: 20em;">Name</th>
    <th>Version</th>
  </tr>
DATA
	foreach my $pkg (@packages) {
		my ($name, $ver, $st) = split(/\t/, $pkg, 3);
		# Skip non-installed packages
		next if ($st ne 'install ok installed');
		my ($name_disp, $ver_disp) = ($name, $ver);
		$name_disp =~ s/&/&amp;/g;
		$ver_disp  =~ s/&/&amp;/g;
		my ($name_id, $ver_id) = ($name, $ver);
		$name_id =~ s/([^a-zA-Z0-9\-_])/sprintf('.%02X', ord($1))/eg;
		$ver_id  =~ s/([^a-zA-Z0-9\-_])/sprintf('.%02X', ord($1))/eg;
		my $pkg_id = "$name_id\:\:$ver_id";
		$table_data .= <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:selectItem('$pkg_id', '${name}_${ver}', true);">
    <td align="center"><input type="checkbox" id="chk-$pkg_id" name="chk-$name_id" onclick="javascript:selectItem('$pkg_id', '${name}_${ver}', false);event.cancelBubble = true;" /></td>
    <td id="item-$pkg_id"><b>$name_disp</b></td>
    <td>$ver_disp</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
	}
}

$table_data .= "</table>\n";
my $delim = ($is_packager_rpm ? '-' : '_');

print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished = true;
var elem_progress_info = document.getElementById('progress_info');
if (elem_progress_info)
	elem_progress_info.style.display = 'none';
// ]]>
</script>

$table_data

<script language="javascript" type="text/javascript">
// <![CDATA[
// Function to represent character as hex code.
function charToHex(ch) {
	var val = ch.charCodeAt(0);
	var val_hi = Math.floor(val / 16);
	var val_lo = val - val_hi * 16;
	return val_hi.toString(16).toUpperCase() + val_lo.toString(16).toUpperCase();
}

function hexToChar(str) {
	var res = 0;
	if ((str[0] >= '0') && (str[0] <= '9'))
		res = str.charCodeAt(0) - 48;
	else
		res = str.charCodeAt(0) - 55;
	res *= 16;
	if ((str[1] >= '0') && (str[1] <= '9'))
		res += str.charCodeAt(1) - 48;
	else
		res += str.charCodeAt(1) - 55;
	return res;
}

// Function to escape string so that it met W3C restrictions on ID HTML attribute.
// Algorithm is the same as used above in Perl-generated HTML list of packages.
function escapeID(str) {
	var res = '';
	for (var i=0; i<str.length; ++i) {
		if (str[i].search(/[^a-zA-Z0-9\\-_]/) == -1)
			res += str[i];
		else
			res += '.' + charToHex(str[i]);
	}
	return res;
}

// Function to unescape the escaped ID string and convert it into normal package name.
function unescapeID(str) {
	var tmp = str.replace(/::/g, '$delim');
	var res = '';
	for (var i=0; i<tmp.length; ++i) {
		if (tmp[i] == '.') {
			res += String.fromCharCode(hexToChar(tmp[i + 1] + tmp[i + 2]));
			i += 2;
		}
		else
			res += tmp[i];
	}
	return res;
}

// Array for storing names of the missing packages.
var wrong_pkgs = new Array();

// Synchronization variable
var check_items_performed = false;

// Checks the elements checkboxes according to the previous selection.
function check_items() {
	// Protect ourselves from JS errors in case the function is called prior to
	// loading the bottom frame. It will be called again from there, so for now
	// simply exit.
	if (!parent.bottom_frame.pkgs_list_complete)
		return;

	// Protect from double-execution, if the first call did succeed.
	if (check_items_performed)
		return;

	check_items_performed = true;
	var new_pkgs_id = new Array();
	var i;

	// Then set the checkmarks.
	for (var pkg in parent.bottom_frame.pkgs_list) {
		if (parent.bottom_frame.pkgs_list[pkg]) {
DATA

if ($is_packager_rpm) {
	print <<DATA;
			// 3 possible variants of input package name:
			//   a) name-version-release
			//   b) name-version
			//   c) name
			// We try to check every one of them (cannot tell for sure:
			// names may contain a hyphen which is a delimiter).
			var pkg_nam1, pkg_ver1, pkg_rel1;       // 'name-version-release' => 'name', 'version', 'release'
			var pkg_nam2, pkg_ver2;                 // 'name-version'         => 'name', 'version', '*'
			var pkg_nam3;                           // 'name'                 => 'name', '*',       '*'
			var elems, tmp;
			var found = false;

			var pkg_id = escapeID(pkg);
			var pos = pkg_id.lastIndexOf('$delim');
			pkg_rel1 = pkg_id.substr(pos + 1);
			tmp = pkg_id.substr(0, pos);
			pos = tmp.lastIndexOf('$delim');
			pkg_ver1 = tmp.substr(pos + 1);
			pkg_ver2 = pkg_rel1;
			pkg_nam1 = tmp.substr(0, pos);
			pkg_nam2 = tmp;
			pkg_nam3 = pkg_id;

			// Check first hypotesis ('name-version-release').
			elems = document.getElementsByName('chk-' + pkg_nam1);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(4);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam1) && (params[1] == pkg_ver1) && (params[2] == pkg_rel1)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check second hypotesis ('name-version').
			elems = document.getElementsByName('chk-' + pkg_nam2);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(4);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam2) && (params[1] == pkg_ver2)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check third hypotesis ('name').
			elems = document.getElementsByName('chk-' + pkg_nam3);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(4);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam3)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// If at least one element was found, reset the source package name.
			// Else mark the package as missing.
			if (found)
				parent.bottom_frame.pkgs_list[pkg] = false;
			else
				wrong_pkgs.push(pkg);
DATA
}
else {
	print <<DATA;
			// 2 possible variants of input package name:
			//   a) name_version
			//   b) name
			// We try to check every one of them (suppose that name
			// cannot contain an underscore, but version can).
			var pkg_nam1, pkg_ver1;                 // 'name_version' => 'name', 'version'
			var pkg_nam2;                           // 'name'         => 'name', '*'
			var elems, tmp;
			var found = false;

			var pkg_id = escapeID(pkg);
			var pos = pkg_id.indexOf('$delim');
			pkg_nam1 = pkg_id.substr(0, pos);
			pkg_ver1 = pkg_id.substr(pos + 1);
			pkg_nam2 = pkg_id;

			// Check first hypotesis ('name_version').
			elems = document.getElementsByName('chk-' + pkg_nam1);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(4);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam1) && (params[1] == pkg_ver1)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check second hypotesis ('name').
			elems = document.getElementsByName('chk-' + pkg_nam2);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(4);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam2)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// If at least one element was found, reset the source package name.
			// Else mark the package as missing.
			if (found)
				parent.bottom_frame.pkgs_list[pkg] = false;
			else
				wrong_pkgs.push(pkg);
DATA
}

print <<DATA;
		}
	}

	// Process all found packages.
	for (i=0; i<new_pkgs_id.length; ++i) {
		var elem_chk = document.getElementById('chk-' + new_pkgs_id[i]);
		var elem_item = document.getElementById('item-' + new_pkgs_id[i]);
		if (elem_chk && elem_item) {
			elem_chk.checked = true;
			elem_item.className = 'selected';
			parent.bottom_frame.pkgs_list[unescapeID(new_pkgs_id[i])] = true;
			++parent.bottom_frame.num_pkgs_list;
		}
		else {
			alert('Internal error while trying to mark package ' + new_pkgs_id[i] + '.\\nPlease, report to linux\@ispras.ru.');
		}
	}

	// Process missing packages if any.
	if (wrong_pkgs.length != 0) {
		var wp_div = document.getElementById('wrong_pkgs');
		var wp_data = document.getElementById('wrong_pkgs_data');
		if (wp_div && wp_data) {
			var str = '<table class="main">\\n';
			for (var i in wrong_pkgs) {
				str += '  <tr>\\n    <td style="width: 1.4em;"><input type="checkbox" name="wp-chk-' + i + '" id="wp-chk-' + i + '" checked="checked" onclick="javascript:selectWPItem(' + i + ');" /></td>\\n    <td id="wp-item-' + i + '" class="selected" style="width: 20em;"><strike><b>' + wrong_pkgs[i].replace(/&/g, '&amp;') + '</b></strike></td>\\n  </tr>\\n';
			}
			str += '</table>\\n';
			wp_data.innerHTML = str;
			wp_div.style.display = '';
		}
		parent.bottom_frame.num_pkgs_list += wrong_pkgs.length;
	}

	var elem = parent.bottom_frame.document.getElementById('num_pkgs');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_pkgs_list;
}

// Updates internal information when (un)selecting packages.
function selectItem(elem_id, pkg_name, set_checkbox) {
	var checkbox = document.getElementById('chk-' + elem_id);
	var item = document.getElementById('item-' + elem_id);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	if (checkbox.checked) {
		parent.bottom_frame.pkgs_list[pkg_name] = true;
		++parent.bottom_frame.num_pkgs_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.pkgs_list[pkg_name] = false;
		--parent.bottom_frame.num_pkgs_list;
		item.className = '';
	}
	var elem = parent.bottom_frame.document.getElementById('num_pkgs');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_pkgs_list;
}

// Updates internal information when (un)selecting missing packages.
function selectWPItem(elem_num) {
	var checkbox = document.getElementById('wp-chk-' + elem_num);
	var item = document.getElementById('wp-item-' + elem_num);
	if (!checkbox || !item)
		return;
	var pkg_name = wrong_pkgs[elem_num];
	if (checkbox.checked) {
		parent.bottom_frame.pkgs_list[pkg_name] = true;
		++parent.bottom_frame.num_pkgs_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.pkgs_list[pkg_name] = false;
		--parent.bottom_frame.num_pkgs_list;
		item.className = '';
	}
	var elem = parent.bottom_frame.document.getElementById('num_pkgs');
	if (elem)
		elem.innerHTML = parent.bottom_frame.num_pkgs_list;
}
// ]]>
</script>


</body>
</html>
DATA
}
else {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Error</title>
</head>

<body>
<h2 style="color: red;">Wrong "_frame" argument!</h2>
</body>
</html>
DATA
}
