#!/usr/bin/perl -w

# LSB Test Execution Framework
# Results Page Module (tests_results.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':flock';
use Fcntl ':seek';

autoflush_on();

if ($_POST{"remove"}) {
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			my $path = $CONFIG{"RESULTS_DIR"}."/$_";
			if (-d $path) {
				if (defined($_POST{$_})) {
					$path =~ s/([ ()])/\\$1/g;
					system("rm -rf $path");
				}
				else {
					push @list, $_;
				}	
			}
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
	}
	else {
		print STDERR "Cannot open HISTORY file!\n";
	}
	print "HTTP/1.0 302 Moved\nLocation: tests_results.pl\n\n";
	exit;
}

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if ($_GET{"details"}) {
	if ($_GET{"analysis"}) {
		my $app_name = "";
		my $res_dir = $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"};
		my $res_dir_esc = $res_dir;
		$res_dir_esc =~ s/([ ()])/\\$1/g;
		if (open(FILE, "$res_dir/INFO")) {
			while (<FILE>) {
				if (m/Application: (.*)$/) {
					$app_name = $1;
					last;
				}
			}
			close(FILE);
		}
		my $app_name_esc = $app_name;
		$app_name_esc =~ s/([ ()])/\\$1/g;
		my $host_platform = `cat $res_dir_esc/test_logs/host_platform`;
		my $lsb_version = `cat $res_dir_esc/test_logs/lsb_version`;
		$host_platform =~ s/[\r\n]//g;
		$lsb_version =~ s/[\r\n]//g;
		my $f_host_platform = lc($host_platform);
		my $name_l = "required_libs";
		my $name_i = "required_ints";
		print_header("Test Report", "analysis");
		print <<DATA;
<h1>LSB $lsb_version Test Results for <font color="blue">$app_name</font> on <font color="blue">$host_platform</font></h1>

You can perform the following additional actions:
<p><a href="upload_data.pl?details=$_GET{'details'}"><img src="images/upload_data_l.png" width="28" height="28" alt="" /></a> You can <a href="upload_data.pl?details=$_GET{'details'}"><b>send this information</b></a> to the Linux Foundation for publishing in the Linux Applications section of the <a href="http://www.linux-foundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a>.</p>
<form action="cert_integration.pl?start" method="post" name="integr_data" style="display:none">
<input type="hidden" name="file" value="$CONFIG{'RESULTS_DIR'}/$_GET{'details'}/$_GET{'details'}.tgz" />
</form>
<p><a href="cert_integration.pl?start" onclick="javascript:document.integr_data.submit(); return false"><img src="images/medal_small.jpg" width="28" height="28" alt="" /></a> If there are no errors, you can easily <a href="cert_integration.pl?start" onclick="document.integr_data.submit(); return false"><b>apply for certification</b></a> by uploading the results to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">LSB Certification System</a>.</p>
<br />
<table cellpadding="0" cellspacing="0" border="0" width="100%" style="white-space: nowrap; font-weight: bold; text-align: center; font-size: 120%;">
  <tr>
    <td style="width: 50px; border-bottom: solid 1px #166a98; height: 2em;"><img src="images/environment-spacer.gif" width="50" height="1" alt="" /></td>
    <td class="res-tab-highlight" style="width: 12em; border: solid 1px #166a98;" onclick="javascript:document.location='tests_results.pl?details=$_GET{'details'}'"><img src="images/environment-spacer.gif" width="10" height="1" alt="" />Test&nbsp;Report<img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td style="width: 10px; border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td style="width: 12em; border: solid 1px #166a98; border-bottom: none; background-color: #a0d5f1; color: #004060;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" />Application&nbsp;Analysis<img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td style="border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="5" style="background-color: #a0d5f1; height: 10px;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
</table>
<br />
DATA
		if ((!-f "$res_dir/$name_l") or (!-f "$res_dir/$name_i")) {
			print <<DATA;
<div id="progress_info">
<font color="green"><b>Please, wait while the list is being generated...</b></font><br />
Time elapsed: <span id="timer" style="font-family: monospace; color: blue;">00:00</span>
</div>

<script language="javascript" type="text/javascript">
// <![CDATA[
var elapsed_time = 0;
var finished = 0;
function update_timer() {
	++elapsed_time;
	var elem = document.getElementById("timer");
	if (elem && !finished) {
		var m = Math.floor(elapsed_time / 60);
		var s = elapsed_time - m * 60;
		var tmp = "";
		tmp += (m < 10) ? "0" + m : m;
		tmp += ":";
		tmp += (s < 10) ? "0" + s : s;
		elem.innerHTML = tmp;
		setTimeout("update_timer()", 1000);
	}
}

setTimeout("update_timer()", 1000);
// ]]>
</script>
DATA
			system("cd ".$CONFIG{"UTILS_DIR"}."; ./merge.pl -d $res_dir_esc $lsb_version $host_platform $res_dir_esc/${app_name_esc}_${f_host_platform}_upload_data >/dev/null");
			print <<DATA;
<script language="javascript" type="text/javascript">
// <![CDATA[
finished=1;
var elem_progress_info = document.getElementById("progress_info");
if (elem_progress_info)
	elem_progress_info.style.display = 'none';
// ]]>
</script>
DATA
		}
		my $request_to_send = "";
		if (! -f "$res_dir/test_logs/ftp_upload") {
			$request_to_send = "<p>Please, <a href=\"upload_data.pl?details=$_GET{details}\"><b>send this information</b></a> to the Linux Foundation for publishing in the Linux Applications section of the <a href=\"http://www.linux-foundation.org/navigator/browse/app.php\" target=\"_blank\">LSB Navigator</a>.</p><br />";
		}
		else {
			$request_to_send = "<br />";
		}
		print <<DATA;
This page contains analytical information about the application you have tested. It contains the following data:
<ol>
  <li><a href="#libs">List of the external <b>libraries</b></a> needed by the application (based on DT_NEEDED ELF section).</li>
  <li><a href="#ints">List of the external <b>interfaces</b></a> actually required by the application to run.</li>
</ol>
$request_to_send

<script language="javascript" type="text/javascript">
// <![CDATA[

var filter = new Array();
filter['ints_table'] = new Array();
filter['ints_table']['lsb'] = 'nlsb';
filter['ints_table']['lib'] = '';
filter['libs_table'] = new Array();
filter['libs_table']['lsb'] = 'nlsb';
filter['libs_table']['lib'] = '';
	
function apply_filter(id, value_lsb, value_lib) {
	var table_name = id + '_table';
	if (value_lsb == "*all*") {
		filter[table_name]['lsb'] = '';
	}
	else if (value_lsb == "ylsb") {
		filter[table_name]['lsb'] = 'ylsb';
	}
	else if (value_lsb == "nlsb") {
		filter[table_name]['lsb'] = 'nlsb';
	}
	if (value_lib == "*all*") {
		filter[table_name]['lib'] = '';
	}
	else if (value_lib != null) {
		filter[table_name]['lib'] = value_lib;
	}

	var table_elem = document.getElementById(table_name);
	var elems = table_elem.getElementsByTagName("TR");
	var num_rows_shown = 0;
	var filter_restriction = '';
	if (filter[table_name]['lsb'] != '') {
		filter_restriction += filter[table_name]['lsb'] + '_' + id;
	}
	if (filter[table_name]['lib'] != '') {
		filter_restriction += ' ' + filter[table_name]['lib'] + '-rule';
	}
	for (var i=0; i<elems.length; ++i) {
		if (!elems[i].className)
			continue;
		if (elems[i].className.indexOf(filter_restriction) != -1) {
			elems[i].style.display = '';
			++num_rows_shown;
		}
		else {
			elems[i].style.display = 'none';
		}
	}

	var elem_empty = document.getElementById(id + '_empty_row');
	var elem_num_shown = document.getElementById(id + '_num_shown');
	if (elem_empty && elem_num_shown) {
		elem_empty.style.display = ((num_rows_shown == 0) ? '' : 'none');
		elem_num_shown.innerHTML = num_rows_shown;
	}
	var elem_empty_text = document.getElementById(id + '_empty_row_text');
	if (elem_empty_text) {
		if (filter[table_name]['lsb'] == 'ylsb')
			elem_empty_text.innerHTML = 'No LSB entries';
		else if (filter[table_name]['lsb'] == 'nlsb')
			elem_empty_text.innerHTML = 'No non-LSB entries';
		else
			elem_empty_text.innerHTML = 'No entries';
	}
	if (filter[table_name]['lib'] != '')
		elem_empty_text.innerHTML += ' in ' + filter[table_name]['lib'];
}
// ]]>
</script>

DATA
		my $buffer = "";
		my $items_num = 0;
		my $nlsb_items_num = 0;
		if (open(FILE_L, "$res_dir/$name_l")) {
			$buffer .= <<DATA;
<table class='bartable'>
  <tr>
    <td align="right"><b>Filter by:</b></td>
    <td align="right">
      Presence in LSB: 
      <select name="lsb_filter_libs" id="lsb_filter_libs" onchange="javascript:apply_filter('libs', this.value, null);" style="width: 12.5em;">
        <option value="*all*">*No filter*</option>
        <option value="ylsb">Show LSB only</option>
        <option value="nlsb" selected="selected">Show non-LSB only</option>
      </select>
    </td>
  </tr>
</table>
<table class="wikitable" id="libs_table">
  <tr>
    <th style="width: 8em;">Library</th>
    <th style="width: 8em;">Interfaces Used</th>
    <th style="width: 4em;">In&nbsp;LSB?</th>
    <th style="width: 33em;">Application&nbsp;Modules</th>
    <th style="width: 25em;">Comments</th>
  </tr>
DATA
			while (<FILE_L>) {
				s/[\r\n]//g;
				my ($soname, $ints_used, $in_lsb, $app_modules, $comments) = split(/;/, $_, 5);
				my $soname_link = $soname;
				$soname_link =~ s/\+/%2B/g;
				if ($ints_used == 0) {
					$ints_used = "<font color=\"red\"><b>0</b></font>";
				}
				my @app_modules_arr = split(/,/, $app_modules);
				$app_modules = '';
				foreach my $component (@app_modules_arr) {
					my $component_disp_path = $component;
					$component =~ s/^.*\.rpm\|([^|]+)/RPM:$1/;
					$component =~ s/^.*\.(tar\.gz|tgz)\|([^|]+)/TGZ:$2/;
					$component =~ s/^PKG:.*\|([^|]+)/PKG:$1/;
					$component =~ s/\|//g;
					$component_disp_path =~ s/\|$//;
					$component_disp_path =~ s/\|/ =&gt; /g;
					$app_modules .= (($app_modules eq '') ? '' : '<br />')."<span title=\"$component_disp_path\">$component</span>";
				}
				if ($comments eq "") {
					$comments = "<font color=\"#a0a0a0\">No information</font>";
				}
				if ($in_lsb) {
					$items_num++;
					$buffer .= "  <tr class=\"ylsb_libs\" style=\"display: none;\"><td><a href=\"http://www.linux-foundation.org/navigator/browse/rawlib.php?cmd=list-byrunname&amp;RLrunname=$soname_link\" target=\"_blank\">$soname</a></td><td align=\"center\">$ints_used</td><td align=\"center\"><font color=\"green\"><b>Yes</b></font></td><td>$app_modules</td><td>$comments</td></tr>\n";
				}
				else {
					$items_num++;
					$nlsb_items_num++;
					$buffer .= "  <tr class=\"nlsb_libs\"><td><a href=\"http://www.linux-foundation.org/navigator/browse/rawlib.php?cmd=list-byrunname&amp;RLrunname=$soname_link\" target=\"_blank\">$soname</a></td><td align=\"center\">$ints_used</td><td align=\"center\"><font color=\"red\"><b>No</b></font></td><td>$app_modules</td><td>$comments</td></tr>\n";
				}
			}
			$buffer .= "<tr id=\"libs_empty_row\"".(($nlsb_items_num == 0) ? "" : " style=\"display: none;\"")."><td colspan=\"5\" align=\"center\"><span id=\"libs_empty_row_text\" style=\"color: #a0a0a0\">No non-LSB entries</span></td></tr>\n";
			$buffer .= "</table>\n";
			close(FILE_L);
		}
		else {
			$buffer .= "<b><font color=\"red\">Sorry, the file '".$_GET{"details"}."/$name_l' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
		print <<DATA;
<a name="libs"></a><h2>List of Required Libraries ($items_num entries total; <span id="libs_num_shown">$nlsb_items_num</span> entries shown)</h2>
$buffer
<br />

DATA

		$buffer = "";
		$buffer0 = "";
		$items_num = 0;
		$nlsb_items_num = 0;
		my %lib_list = ();
		if (open(FILE_I, "$res_dir/$name_i")) {
			$buffer0 = <<DATA;
<table class='bartable'>
  <tr>
    <td align="right"><b>Filter by:</b></td>
    <td align="right">
      Presence in LSB: 
      <select name="lsb_filter_ints" id="lsb_filter_ints" onchange="javascript:apply_filter('ints', this.value, null);" style="width: 12.5em;">
        <option value="*all*">*No filter*</option>
        <option value="ylsb">Show LSB only</option>
        <option value="nlsb" selected="selected">Show non-LSB only</option>
      </select>
    </td>
    <td align="right">
      Library: 
      <select name="lsb_filter_ints_l" id="lsb_filter_ints_l" onchange="javascript:apply_filter('ints', null, this.value);" style="width: 12.5em;">
        <option value="*all*">*No filter*</option>
DATA
			$buffer = <<DATA;
      </select>
    </td>
  </tr>
</table>
<table class="wikitable" id="ints_table">
  <tr>
    <th style="width: 33em;">Interface</th>
    <th style="width: 6em;">Library</th>
    <th style="width: 4em;">In&nbsp;LSB?</th>
    <th style="width: 33em;">Application&nbsp;Modules</th>
    <th style="width: 25em;">Comments</th>
  </tr>
DATA
			while (<FILE_I>) {
				s/[\r\n]//g;
				my @line = split(/;/, $_, 7);
				my ($mgl_name, $disp_name, $version, $in_lsb, $app_modules, $lib_name, $comments) = split(/;/, $_, 7);
				$lib_list{$lib_name} = 1;
				my $tooltip = "";
				my $cont_text = "";
				if ($disp_name eq "") {
					$disp_name = $mgl_name;
					if (length($disp_name) > 50) {
						$tooltip = " title=\"$disp_name\"";
						$cont_text = " <font color=\"red\">&raquo;</font>";
						$disp_name = substr($disp_name, 0, 50)."...";
					}
				}
				$disp_name =~ s/&/&amp;/g;
				$disp_name =~ s/</&lt;/g;
				$disp_name =~ s/>/&gt;/g;
				my @app_modules_arr = split(/,/, $app_modules);
				$app_modules = '';
				foreach my $component (@app_modules_arr) {
					my $component_disp_path = $component;
					$component =~ s/^.*\.rpm\|([^|]+)/RPM:$1/;
					$component =~ s/^.*\.(tar\.gz|tgz)\|([^|]+)/TGZ:$2/;
					$component =~ s/^PKG:.*\|([^|]+)/PKG:$1/;
					$component =~ s/\|//g;
					$component_disp_path =~ s/\|$//;
					$component_disp_path =~ s/\|/ =&gt; /g;
					$app_modules .= (($app_modules eq '') ? '' : '<br />')."<span title=\"$component_disp_path\">$component</span>";
				}
				my $lib_name_disp = $lib_name;
				if ($lib_name) {
					$lib_name_disp =~ s/\+/%2B/g;
					$lib_name_disp = "<a href=\"http://www.linux-foundation.org/navigator/browse/lib_single.php?cmd=list-by-name&amp;Lname=$lib_name_disp\" target=\"_blank\">$lib_name</a>";
				}
				else {
					$lib_name_disp = '<font color="#a0a0a0">&lt;Undefined&gt;</font>';
					$lib_name = '-undef-';
				}
				if ($comments eq "") {
					$comments = "<font color=\"#a0a0a0\">No information</font>";
				}
				if ($in_lsb) {
					$items_num++;
					$buffer .= "  <tr class=\"ylsb_ints $lib_name-rule\" style=\"display: none;\"><td style=\"white-space: normal;\"><a href=\"http://www.linux-foundation.org/navigator/browse/int_single.php?cmd=list-by-name&amp;Iname=$mgl_name\" target=\"_blank\"$tooltip>$disp_name</a>$cont_text</td><td>$lib_name_disp</td><td align=\"center\"><font color=\"green\"><b>Yes</b></font></td><td>$app_modules</td><td>$comments</td></tr>\n";
				}
				else {
					$items_num++;
					$nlsb_items_num++;
					$buffer .= "  <tr class=\"nlsb_ints $lib_name-rule\"><td style=\"white-space: normal;\"><a href=\"http://www.linux-foundation.org/navigator/browse/int_single.php?cmd=list-by-name&amp;Iname=$mgl_name\" target=\"_blank\"$tooltip>$disp_name</a>$cont_text</td><td>$lib_name_disp</td><td align=\"center\"><font color=\"red\"><b>No</b></font></td><td>$app_modules</td><td>$comments</td></tr>\n";
				}
			}
			$buffer .= "<tr id=\"ints_empty_row\"".(($nlsb_items_num == 0) ? "" : " style=\"display: none;\"")."><td colspan=\"5\" align=\"center\"><span id=\"ints_empty_row_text\" style=\"color: #a0a0a0\">No non-LSB entries</span></td></tr>\n";
			$buffer .= "</table>\n\n";
			close(FILE_I);
		}
		else {
			$buffer .= "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."/$name_i' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
		foreach (sort keys %lib_list) {
			if ($_) {
				$buffer0 .= "  <option value=\"$_\">$_</option>\n";
			}
			else {
				$buffer0 .= "  <option value=\"-undef-\">&lt;Undefined&gt;</option>\n";
			}
		}
		print <<DATA;
<a name="ints"></a><h2>List of Required Interfaces ($items_num entries total; <span id="ints_num_shown">$nlsb_items_num</span> entries shown)</h2>
$buffer0$buffer
DATA
	}
	else {
		my $name = "test_log.html";
		print_header("Test Report", "report");
		if (open(FILE, $CONFIG{"RESULTS_DIR"}."/".$_GET{"details"}."/$name")) {
			my $transfer = 0;
			while (<FILE>) {
				if (m/<body>/) {
					s/^.*<body>\n?//i;
					$transfer = 1;
				}
				if ($transfer) {
					s/(<\/body>|<\/html>)\n?//i;
					if (m/<!-- Test Report Header -->/) {
						print <<DATA;
You can perform the following additional actions:
<p><a href="upload_data.pl?details=$_GET{'details'}"><img src="images/upload_data_l.png" width="28" height="28" alt="" /></a> You can <a href="upload_data.pl?details=$_GET{'details'}"><b>send this information</b></a> to the Linux Foundation for publishing in the Linux Applications section of the <a href="http://www.linux-foundation.org/navigator/browse/app.php" target="_blank">LSB Navigator</a>.</p>
<form action="cert_integration.pl?start" method="post" name="integr_data" style="display:none">
<input type="hidden" name="file" value="$CONFIG{'RESULTS_DIR'}/$_GET{'details'}/$_GET{'details'}.tgz" />
</form>
<p><a href="cert_integration.pl?start" onclick="javascript:document.integr_data.submit(); return false"><img src="images/medal_small.jpg" width="28" height="28" alt="" /></a> If there are no errors, you can easily <a href="cert_integration.pl?start" onclick="document.integr_data.submit(); return false"><b>apply for certification</b></a> by uploading the results to the <a href="http://$cert_sys_host$cert_sys_base" target="_blank">LSB Certification System</a>.</p>
<br />
<table cellpadding="0" cellspacing="0" border="0" width="100%" style="white-space: nowrap; font-weight: bold; text-align: center; font-size: 120%;">
  <tr>
    <td style="width: 50px; border-bottom: solid 1px #166a98; height: 2em;"><img src="images/environment-spacer.gif" width="50" height="1" alt="" /></td>
    <td style="width: 12em; border: solid 1px #166a98; border-bottom: none; background-color: #a0d5f1; color: #004060;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" />Test&nbsp;Report<img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td style="width: 10px; border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td class="res-tab-highlight" style="width: 12em; border: solid 1px #166a98;" onclick="javascript:document.location='tests_results.pl?details=$_GET{'details'}&amp;analysis=1'"><img src="images/environment-spacer.gif" width="10" height="1" alt="" />Application&nbsp;Analysis<img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
    <td style="border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="5" style="background-color: #a0d5f1; height: 10px;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
</table>
DATA
					}
					else {
						print $_;
					}
				}
			}
			close(FILE);
		}
		else {
			print "<b><font color=\"red\">Sorry, the report '".$_GET{"details"}."' cannot be opened!</font><br />\nReason: $!</b>\n";
		}
	}
}
else {
	print_header("Test Results", "results");

	print "<h1>Test Results</h1>\n";

	print "<form method=\"post\" action=\"tests_results.pl\" name=\"results_list\">\n<table class=\"main\">\n";
	print "  <tr>\n    <td><input type=\"checkbox\" name=\"check_all\" id=\"check_all\" onclick=\"javascript:check_unckeck_all();\" /></td>\n";
	print "    <th style=\"width: 14em;\">Date/Time</th>\n";
	print "    <th style=\"width: 14em;\">Summary</th>\n";
	print "    <th style=\"width: 25em;\">Comment</th>\n  </tr>\n";
	my @list = ();
	if (open(FILE, "+<".$CONFIG{"RESULTS_DIR"}."/HISTORY")) {
		flock(FILE, LOCK_EX);
		while(<FILE>) {
			s/[\r\n]//g;
			next if ($_ eq "");
			push @list, $_ if (-d $CONFIG{"RESULTS_DIR"}."/$_");
		}
		seek(FILE, 0, SEEK_SET);
		truncate(FILE, 0);
		print FILE join("\n", @list)."\n";
		flock(FILE, LOCK_UN);
		close(FILE);
		@list = reverse(@list);
		foreach my $name (@list) {
			$_ = $CONFIG{"RESULTS_DIR"}."/$name";
			my @summary = ();
			my @comment = ();
			my $current_field = \@summary;
			if (open(FILE, "$_/INFO")) {
				while (<FILE>) {
					s/&/&amp;/g;
					s/</&lt;/g;
					s/>/&gt;/g;
					s/[\r\n]//g;
					if (($_ eq "") and ($current_field != \@comment)) {
						$current_field = \@comment;
						next;
					}
					push @$current_field, $_;
				}
				close(FILE);
			}
			my $fail = -1;
			my $app_name = "";
			my @extraction = ();
			foreach (@summary) {
				if (m/^Verdict: (\S+)/i) {
					if ($1 eq "Success") {
						$fail = 0;
					}
					elsif ($1 eq "Warnings") {
						$fail = 0;
					}
					elsif ($1 eq "Failed") {
						$fail = 1;
					}
					elsif ($1 eq "No result") {
						$fail = 2;
					}
				}
				elsif (m/^Application: (.*)$/i) {
					$app_name = $1;
				}
				else {
					# Align numbers by right side (6 digits max)
					s/^(\d+) /("&nbsp;"x(6-length($1))).$1." "/e;
					push @extraction, $_;
				}
			}
			my $jsummary = join("<br />", @extraction);
			$jsummary = "&nbsp;" if ($jsummary eq "");
			my $jcomment = join("<br />", @comment);
			if ($jcomment ne "") {
				$jcomment =~ s/&gt;/>/g;
				$jcomment =~ s/&lt;/</g;
				$jcomment =~ s/&amp;/&/g;
			}
			else {
				$jcomment = "&nbsp;";
			}
			my $image = "";
			my $img_alt = "";
			if ($fail == -1) {
				$fail = ($jsummary =~ m/(\d+) Tests Failed/) ? ($1 ? 1 : 0) : -1;
			}
			if ($fail) {
				$image = "TestsFailed.png";
				$img_alt = "TestsFailed";
			}
			else {
				$image = "TestsPassed.png";
				$img_alt = "TestsPassed";
			}
			my $show_name = $name;
			$show_name =~ s/^.*-([^\-]*)\-([^\-]*)\-([^\-]*)\-([^\-]*)h\-([^\-]*)m\-([^\-]*)s/$3.$2.$1&nbsp;$4:$5:$6/;
			my $upload_icon = "";
			if (! -f $CONFIG{"RESULTS_DIR"}."/$name/test_logs/ftp_upload") {
				$upload_icon = "&nbsp;<a href=\"upload_data.pl?details=$name\" title=\"Upload Data to the Linux Foundation\"><img src=\"images/upload_data.png\" alt=\"\" width=\"16\" height=\"16\" /></a>";
			}
			print <<DATA;
  <tr>
    <td rowspan="3"><input type='checkbox' name='$name' onclick='javascript:update_state();' /></td>
    <td rowspan="1" style="border-bottom: none;"><img src="images/environment-spacer.gif" width="1" height="16" alt="" /></td>
    <td rowspan="3" valign="top"><code>$jsummary</code></td>
    <td rowspan="3" valign="top">$jcomment</td>
  </tr>
  <tr>
    <td valign="middle" style="border: none;">
      <table cellpadding="0" cellspacing="0" border="0"><tr>
        <td style="border: none; padding: 0px;"><img src="images/$image" alt="$img_alt" width="33" height="30" /></td>
        <td style="border: none; padding: 0px;">&nbsp;<a href="tests_results.pl?details=$name">$show_name</a><br />&nbsp;Application: $app_name</td>
      </tr></table>
    </td>
  </tr>
  <tr>
    <td style="border: none; text-align: right; vertical-align: bottom;" width="5" height="5">
      <a href="tests_results.pl?details=$name" title="Show detailed report"><img src="images/report_details.gif" alt="" width="16" height="16" /></a>&nbsp;<a href="tests_results.pl?details=$name&amp;analysis=1" title="Show analysis results"><img src="images/report_summary.gif" alt="" width="16" height="16" /></a>$upload_icon
    </td>
  </tr>
DATA
		}
	}
	print <<DATA;
</table>
<br /><input type="submit" name="remove" id="remove_button" value="Remove Selected Entries" disabled="disabled" onclick='javascript:return confirm_remove();' />
</form>

<script language="javascript" type="text/javascript">
// <![CDATA[
function count_checked() {
	var num = 0;
	var form = document.results_list;
	for (var i=0; i<form.length; ++i) {
		if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all") && form[i].checked) {
			++num;
		}
	}
	return num;
}

function update_state() {
	var elem = document.getElementById("remove_button");
	if (elem) {
		var num = count_checked();
		elem.disabled = (num == 0);
	}
}

function check_unckeck(box, check) {
	temp = box.onchange;
	box.onchange = null;
	box.checked = check;
	box.onchange = temp;
}

function check_unckeck_all() {
	var elem = document.getElementById("check_all");
	if (elem) {
		var checked = elem.checked;
		var form = document.results_list;
		for (var i=0; i<form.length; ++i) {
			if ((form[i].type.toLowerCase() == "checkbox") && (form[i].name != "check_all"))
				check_unckeck(form[i], checked);
		}
		update_state();
	}
}

function confirm_remove() {
	var num = count_checked();
	if (num == 0) {
		alert("Nothing selected!");
		return false
	}
	else
		return confirm("Do you wish to delete " + num + " selected report(s)?");
}
// ]]>
</script>
DATA
}

print_footer();
